/*
  model.js

  This file is required. It must export a class with at least one public function called `getData`

  Documentation: http://koopjs.github.io/docs/specs/provider/
*/
'use strict'
const ttl = 60 * 60


const request = require('request').defaults({gzip: true})
request.params={
	id:'pasadenaCallsForService',
	statsSupport:true
	}
function isEmpty(obj){
	 for( var key in obj) {
		 if(obj.hasOwnProperty(key)) {
			 return false
		 }
 }
 return true
 }
//This config object will collect the credentials needed to process a valid request.
//Be sure you add you credentials to the default.json in the config folder
const config = require('./config/default.json')


function Model (koop) {}

Model.prototype.getData = function (req, callback) {
  var moment = require('moment')
  const USER = config.pulsepoint.username
  const PSWD = config.pulsepoint.pass 
  const key = config.pulsepoint.key
  const contentType = "application/json" 
  const dataType = 'json'
  var layersdd


  // Call the remote API with our developer key
  // please consult the PulsePoint Documentation for additional parameters you would like to add to the URL
  var myUrls =[`https://${USER}:${PSWD}@api.pulsepoint.org/v1/incidents?apikey=${key}&agencyid=19145&active=1`,`https://${USER}:${PSWD}@api.pulsepoint.org/v1/incidents?apikey=${key}&agencyid=19145&recent=1`]
  const urls = myUrls
  const layersName = ["Pasadena Calls For Service //Active ","Pasadena Calls For Service //Recent"]
  layersdd = req.params.layer > urls.length-1 ? 0:req.params.layer
  console.log("layer: "+layersdd)
  request(urls[layersdd], (error, response, body) => {

	
    if (error) return callback(error)
	console.log("Request_fulfilled")
    // translate the response into geojson
	
	
    const geojson = translate(body)
	
	
	
	
	
	
	geojson.metadata ={
		name: layersName[layersdd],
		description: layersName[layersdd],
		displayField:"IncidentNumber",
		idField: "OBJECTID",
		geometryType: "Point",
		
		
	}
    // Optional: cache data for 10 seconds at a time by setting the ttl or "Time to Live"
    // geojson.ttl = 10


    // hand off the data to Koop
    callback(null, geojson)
  })
}
// this function formats the data so it can be converted to a valid GEOJSON
function translate (data) {
  const list = JSON.parse(data)
  const featureCollection = {
    type: 'FeatureCollection',
    features: []
  }
  if (!isEmpty(list)){
 list.incidents.forEach(function(object){
	  featureCollection.features.push(formatFeature(object))//append Feature
	  
  })
  console.log("True")
  return featureCollection
  }
  else {
	 return featureCollection
  }
}
function second_format(seconds){
    var sec = seconds%60
    var min = parseInt(seconds/60)
    var minutes = min%60
    var hours = parseInt(min/60)

    return hours.toString()+":"+minutes.toString()+":"+sec.toString()
}
// this function converts a record into a valid GEOJSON
//Consult the PulsePoint API documentation for valid Properties  that can be pulled from the API
function formatFeature (incdnt) {
	var moment = require('moment')
	
    var DDT = (incdnt.DispatchDateTime)?moment(incdnt.DispatchDateTime):null;
	var EDT = (incdnt.EntryDateTime)?moment(incdnt.EntryDateTime):null;
	var CRDT =(incdnt.CallReceivedDateTime)?moment(incdnt.CallReceivedDateTime):null;
    var OSDT = (incdnt.OnSceneDateTime)?moment(incdnt.OnSceneDateTime):null;
    var ENROUTE =(incdnt.EnrouteDateTime)?moment(incdnt.EnrouteDateTime):null;
	var CDT = (incdnt.ClosedDateTime)?moment(incdnt.ClosedDateTime):null;
  const feature =  {
    type: 'Feature',
    geometry: {
      type: 'Point',
      coordinates: [parseFloat(incdnt.Longitude), parseFloat(incdnt.Latitude)]
    },
    properties: {
	  OBJECTID: parseInt(incdnt.ID),
	  AgencyID: incdnt.AgencyID,
      IncidentNumber: incdnt.IncidentNumber,
	  EMDIncidentNumber: incdnt.EMDIncidentNumber,
	  CallSource: incdnt.CallSource,
      StreetNumber: incdnt.StreetNumber,
	  Predirectional: incdnt.Predirectional,
	  Street: incdnt.StreetName,
	  StreetSuffix: incdnt.StreetSuffix, 
	  Postdirectional: incdnt.PostDirectional,
	  Suite: incdnt.Suite,
	  Building: incdnt.Building,
	  Floor: incdnt.Floor,
	  City: incdnt.CityOrLocality,
	  County: incdnt.County,
	  State: incdnt.StateOrPovince,
	  PostalCode: incdnt.PostalCode,
	  CrossStreet1: incdnt.CrossStreet1,
	  CrossStreet2: incdnt.CrossStreet2,
	  CommonPlaceName: incdnt.CommonPlaceName,
	  Latitude: incdnt.Latitude,
	  Longitude: incdnt.Longitude,
	  PopulationDensity: incdnt.PopulationDensity,
	  FireManagementZone: incdnt.FireManagementZone,
	  Battalion: incdnt.Battalion,
	  Jurisdiction: incdnt.Jurisdiction,
	  PulsePointIncidentCallType: incdnt.PulsePointIncidentCallType,
	  AgencyIncidentCallType: incdnt.AgencyIncidentCallType,
	  AgencyIncidentCallTypeDescription: incdnt.AgencyIncidentCallTypeDescription,
	  AgencyDeterminantCode: incdnt.AgencyDeterminantCode,
	  AlarmLevel: incdnt.AlarmLevel,
	  Priority: incdnt.Priority,
	  CommandName: incdnt.CommandName,
	  TacticalChannel: incdnt.TacticalChannel,
	  CallReceivedDateTime: incdnt.CallReceivedDateTime,
	  EMDDeterminantCompleteDateTime: incdnt.EMDDeterminantCompleteDateTime,
	  DispatchDateTime: incdnt.DispatchDateTime,
	  EnrouteDateTime: incdnt.EnrouteDateTime,
	  OnSceneDateTime: incdnt.OnSceneDateTime,
	  WorkingFireDateTime: incdnt.WorkingFireDateTime,
	  AmbulanceArrivalDateTime: incdnt.AmbulanceArrivalDateTime,
	  PatientSideDateTime: incdnt.PatientSideDateTime,
	  EffectiveResponseForceDateTime: incdnt.EffectiveResponseForceDateTime,
	  UnitControlDateTime: incdnt.UnitControlDateTime,
	  ClosedDateTime: incdnt.ClosedDateTime,
	  EntryDateTime: incdnt.EntryDateTime,
	  IncidentLastUpdate: incdnt.IncidentLastUpdate,
	  AlarmHandling : (DDT&&(EDT||CRDT))?DDT.diff((EDT.isBefore(CRDT)||!(EDT))?EDT:CRDT,"seconds"):null,
	  TurnoutTime: (DDT&&ENROUTE)?ENROUTE.diff(DDT,"seconds"):null,
	  TravelTime: (OSDT&&ENROUTE)?OSDT.diff(ENROUTE,"seconds"):null,
	  TotalResponse:(OSDT&&(EDT||CRDT))? OSDT.diff((EDT.isBefore(CRDT)||!(EDT))?EDT:CRDT,"seconds"):null,
	  ResponseTime:(OSDT&&DDT)?OSDT.diff(DDT,"seconds"):null,
	  Utilization: (DDT&&CDT)?CDT.diff(DDT,"seconds"):null
	  
    }
	
  }
  if(incdnt.Unit){
  var string = "";
  for(var i = 0; i < incdnt.Unit.length; i++){
	  string += incdnt.Unit[i].UnitID+", "
  }
  feature.properties.UnitID = string.slice(0,-2); 
  }

 return feature
}
function dateFormat (date) {
  return new Date(parseInt(date, 10) * 1000).toISOString()
}

module.exports = Model

/* Example provider API:
   - needs to be converted to GeoJSON Feature Collection
{
  "resultSet": {
  "queryTime": 1488465776220,
  "vehicle": [
    {
      "tripID": "7144393",
      "signMessage": "Red Line to Beaverton",
      "expires": 1488466246000,
      "serviceDate": 1488441600000,
      "time": 1488465767051,
      "latitude": 45.5873117,
      "longitude": -122.5927705,
    }
  ]
}

Converted to GeoJSON:

{
  "type": "FeatureCollection",
  "features": [
    "type": "Feature",
    "properties": {
      "tripID": "7144393",
      "signMessage": "Red Line to Beaverton",
      "expires": "2017-03-02T14:50:46.000Z",
      "serviceDate": "2017-03-02T08:00:00.000Z",
      "time": "2017-03-02T14:42:47.051Z",
    },
    "geometry": {
      "type": "Point",
      "coordinates": [-122.5927705, 45.5873117]
    }
  ]
}
*/
